/* Author: Nathan Zorndorf
 * Description: Audio to MIDI converter. 
 * modified by Tyler Olivieri
 * for graphic EQ (spectrum analyzer)
 */
//#include <csl_uart.h>
#include <stdio.h>
#include <math.h> 
#include <tms320.h>
#include <Dsplib.h>
#include <my_types.h>
#include <usbstk5505.h>
#include <Application_1_Modified_Registers.h>
#include <My_PLL.h>
#include <My_I2C.h> 
#include <My_AIC3204.h>
#include <My_I2S_Register.h>
#include <My_DMA_Ping_Pong_Register_Setup.h>
#include <My_UART.h>

//#include <Audio_Straight_Through_Using_DMA.h>
//#include "spectrumAnalyzer_DMA_cfft.h"
//#include "tyler_FIR_uart.h"


// Buffers for DMA in/out and overlap-add 
Int16 PingPongFlagInL;
Int16 PingPongFlagInR;
Int16 PingPongFlagOutL;
Int16 PingPongFlagOutR;

Int16 DMA_InpL[PING_PONG_SIZE];
Int16 DMA_InpR[PING_PONG_SIZE];
Int16 DMA_OutL[PING_PONG_SIZE];
Int16 DMA_OutR[PING_PONG_SIZE];

#define BUFFER_SIZE 256

	/*declare buffers to hold samples */
	Int16 wLeft[BUFFER_SIZE];
	Int16 wRight[BUFFER_SIZE];
	long long outRight = 1;
	long outLeft;
	unsigned long int p = 0;
    unsigned long int q = 0;
    unsigned long int i = 0;
    int size = 0;
    Int16 sample;
    Int16 filt_sample = 0;
	Int16 debugBuf[BUFFER_SIZE];
	extern Int16 h[BUFFER_SIZE];
	Int16 test = 1;
	//Int16 debugBuf[BUFFER_SIZE] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    //Int16 sample[BUFFER_SIZE] = {32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767};
    //Int16 h[BUFFER_SIZE] = {32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767,32767, 32767, -32767, -32767};
int main(void) {
	
 	My_PLL();
    
 	IER0 = 0xC100; // DMA, I2S RX/TX Interrupt Enable. 
 	//asm(" BIT (ST1, #ST1_INTM) = #0"); 
 	    
 	My_I2C();
 	 
 	My_AIC3204();

	My_DMA_Ping_Pong_Register_Setup();

	My_UART(); // setup UART and transmit test sequence
	
	
	My_I2S_Register();
	
	//Audio_Straight_Through_Using_DMA(); // just to test everything is working before moving onto the real deal
	
	//spectrumAnalyzer_DMA_cfft();

	//grab sample from uart 
    //this might be slow but whatever
     
	for ( i = 0; i<(79370* 6); i++){
   		
		sample = tyler_FIR_uart((Int16) outRight);  
		debugBuf[0] = sample;
    	//filt_sample = tyler_FIR(debugBuf, h);
        outRight = 0;
		for(q= 0; q<=(BUFFER_SIZE -1); q++){
			 outRight += h[q]*(long long)debugBuf[q];
		}
		
	
		//Shift by 22 16+16 = 32 + 8(sum) = 40 
		//39-16 = 23
		outRight = outRight >> 16; 
    	memmove(&debugBuf[1], &debugBuf[0], sizeof(Int16)*(BUFFER_SIZE -1));
   
   	}//???
   	
   	
   	
	printf("Reached end of main!\n");
	
 	return(1);
}









